/*
 * Copyright 2009 Red Hat, Inc. Red Hat licenses this file to you under the Apache License, version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of the License at
 * http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under
 * the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under the License.
 */
package com.siemag.mdb;

import javax.annotation.Resource;
import javax.ejb.ActivationConfigProperty;
import javax.ejb.MessageDriven;
import javax.ejb.MessageDrivenContext;
import javax.ejb.TransactionManagement;
import javax.ejb.TransactionManagementType;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.jms.ObjectMessage;

/**
 * @author <a href="mailto:andy.taylor@jboss.org">Andy Taylor</a>
 */
@MessageDriven(
    mappedName = "MDB_BMTExample",
    activationConfig = {
        @ActivationConfigProperty(propertyName = "destinationType", propertyValue = "javax.jms.Topic"),
        @ActivationConfigProperty(propertyName = "destination", propertyValue = "topic/testopic"),
        @ActivationConfigProperty(propertyName = "subscriptionDurability", propertyValue = "Durable"),
        @ActivationConfigProperty(propertyName = "clientID", propertyValue = "MDB_BMTExampleClient"),
        @ActivationConfigProperty(propertyName = "maxSession", propertyValue = "1") })
//@TransactionManagement(value = TransactionManagementType.BEAN)
@TransactionManagement(value = TransactionManagementType.CONTAINER)
//@ResourceAdapter("hornetq-ra.rar")
public class MDB_BMTExample implements MessageListener
{
  @Resource
  MessageDrivenContext ctx;

  public void onMessage(final Message message)
  {
    try
    {
      ctx.setRollbackOnly();
      // Step 9. We know the client is sending a text message so we cast
      ObjectMessage textMessage = (ObjectMessage)message;

      // Step 10. get the text from the message.
      String text = textMessage.getObject().toString();

      System.out.println("message " + text + " received");

      // Step 11. lets look at the user transaction to make sure there isn't one.
      //      UserTransaction tx = ctx.getUserTransaction();

      //      if (tx != null)
      //      {
      //        tx.begin();
      //      System.out.println("we are in the middle of a transaction: ");
      //        tx.commit();

      //        tx.rollback();
      //      System.out.println("transaction rolled back");
      //      }
      //      else
      //      {
      //        System.out.println("something is wrong, I was expecting a transaction");
      //      }
    } catch (Exception e)
    {
      e.printStackTrace();
    }
  }
}
