package com.siemag.mdb;

import java.text.SimpleDateFormat;
import java.util.Date;

import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;
import javax.annotation.Resource;
import javax.ejb.ActivationConfigProperty;
import javax.ejb.MessageDriven;
import javax.ejb.MessageDrivenContext;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.jms.ObjectMessage;

import org.jboss.logging.Logger;

/**
 * Message-Driven Bean implementation class for: Tel100RCV
 *
 */

@MessageDriven(
    activationConfig = {
        @ActivationConfigProperty(propertyName = "destinationType", propertyValue = "javax.jms.Topic"),
        @ActivationConfigProperty(propertyName = "destination", propertyValue = "topic/MES"),
        @ActivationConfigProperty(propertyName = "subscriptionDurability", propertyValue = "Durable"),
        @ActivationConfigProperty(propertyName = "clientID", propertyValue = "Tel100Client"),
        @ActivationConfigProperty(propertyName = "maxSession", propertyValue = "1") }, mappedName = "Tel100RCV")
//    Default is Auto-acknowledge
//        @ActivationConfigProperty(propertyName = "acknowledgeMode", propertyValue = "Auto-acknowledge")
//        @ActivationConfigProperty(propertyName = "acknowledgeMode", propertyValue = "Dups_ok_acknowledge")
//@TransactionManagement(TransactionManagementType.BEAN)
//@TransactionAttribute(TransactionAttributeType.REQUIRED)
//@ResourceAdapter("hornetq-ra.rar")
public class Tel100RCV implements MessageListener {

  Logger                       lLog = Logger.getLogger(Tel100RCV.class);

  @Resource
  private MessageDrivenContext mdc;

  /**
   * Default constructor.
   */
  public Tel100RCV() {
    lLog.info("Constructor called  " + hashCode());
  }

  /**
     * @see MessageListener#onMessage(Message)
     */
  public void onMessage(Message message){
    if (message instanceof ObjectMessage) {

      ObjectMessage lTextMessage = (ObjectMessage)message;
      try {
        //        mdc.getUserTransaction().begin();
        //        lLog.info(message.getJMSReplyTo() + " " + message.getJMSMessageID() + " " + message.getJMSDestination());
        mdc.setRollbackOnly();
        Date lDate = new Date();
        SimpleDateFormat sdf = new SimpleDateFormat("MMM dd-yyyy HH:mm:ss-SSSS");
        lDate.setTime(lTextMessage.getJMSTimestamp());
        lLog.info(lTextMessage.getObject().toString() + " " + mdc.getRollbackOnly() + " hashCode " + hashCode() + " timestamp "
            + sdf.format(lDate));
        //        mdc.getUserTransaction().rollback();
        //        mdc.getUserTransaction().commit();
      } catch (Exception e) {
        lLog.error("FEHLER", e);
      }
    } else {
      lLog.info(message.toString());
    }
  }

  @PostConstruct
  public void create(){
    lLog.info("Create " + hashCode());
  }

  @PreDestroy
  public void destroy(){
    lLog.info("destory " + hashCode());
  }
}
